package com.bzd.web.controller.jkgl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.jkgl.SJkglGyhyYjtjActivityinfoService;

import java.util.List;

/**
*
* 有奖推荐活动信息表 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "jkgl/sjkglgyhyyjtjactivityinfo")
public class SJkglGyhyYjtjActivityinfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "jkgl";

    @Autowired
    private SJkglGyhyYjtjActivityinfoService sJkglGyhyYjtjActivityinfoService;

    /**
    * 有奖推荐活动信息表 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglGyhyYjtjActivityinfoAdd")
    public String add() {
        return prefix + "/SJkglGyhyYjtjActivityinfoAdd";
    }

    /**
    * 有奖推荐活动信息表 新增
    *
    * @return
    */
    @Log(title = "有奖推荐活动信息表新增", businessType = BusinessType.INSERT)
    @PostMapping("/sJkglGyhyYjtjActivityinfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sJkglGyhyYjtjActivityinfoService.addSJkglGyhyYjtjActivityinfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 有奖推荐活动信息表 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("jkgl:jk:view")
    @GetMapping("/sJkglGyhyYjtjActivityinfoView")
    public String sjkglgyhyyjtjactivityinfoListView() {
        return prefix + "/SJkglGyhyYjtjActivityinfoList";
    }

    /**
    * 有奖推荐活动信息表 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:sJkglGyhyYjtjActivityinfoList")
    @PostMapping("/sJkglGyhyYjtjActivityinfoList")
    @ResponseBody
    public TableDataInfo sjkglgyhyyjtjactivityinfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sJkglGyhyYjtjActivityinfoService.findSJkglGyhyYjtjActivityinfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 有奖推荐活动信息表 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:remove")
    @Log(title = "有奖推荐活动信息表删除", businessType = BusinessType.DELETE)
    @PostMapping("/sJkglGyhyYjtjActivityinfoRemove")
    @ResponseBody
    public AjaxResult sjkglgyhyyjtjactivityinfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sJkglGyhyYjtjActivityinfoService.SJkglGyhyYjtjActivityinfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 有奖推荐活动信息表 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("jkgl:jk:edit")
    @GetMapping("/sJkglGyhyYjtjActivityinfoEdit/{id}")
    public String sjkglgyhyyjtjactivityinfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sJkglGyhyYjtjActivityinfoService.findSJkglGyhyYjtjActivityinfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/sjkglgyhyyjtjactivityinfoPageEdit";
        }
        return prefix+ "/sjkglgyhyyjtjactivityinfoEdit";
    }

    /**
    * 有奖推荐活动信息表保存修改的数据
    */
    @RequiresPermissions("jkgl:jk:edit")
    @Log(title = "有奖推荐活动信息表修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sJkglGyhyYjtjActivityinfoEdit")
    @ResponseBody
    public AjaxResult sjkglgyhyyjtjactivityinfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sJkglGyhyYjtjActivityinfoService.updateSJkglGyhyYjtjActivityinfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表sjkglgyhyyjtjactivityinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表sjkglgyhyyjtjactivityinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
